// DS12C887 ̿  ð

#include <reg51.h>

#define RTC_SEC (*(unsigned char *) 0x20000)
#define RTC_MIN (*(unsigned char *) 0x20002)
#define RTC_HOR (*(unsigned char *) 0x20004)
#define RTC_DAY (*(unsigned char *) 0x20006)
#define RTC_DAT (*(unsigned char *) 0x20007)
#define RTC_MON (*(unsigned char *) 0x20008)
#define RTC_YER (*(unsigned char *) 0x20009)
#define REGA (*(unsigned char *) 0x2000a)
#define REGB (*(unsigned char *) 0x2000b)

sbit busy_flag=P0^7;		// LCD  ˻ ÷

sbit sw1=P1^0;			// (ð   )
sbit sw2=P1^1;			// ׸ (, ,  )
sbit sw3=P1^2;			//  ׸ 
sbit sw4=P1^3;			//  
sbit RTC_CS=P1^7;		// DS12C887 CS

sbit LCD_RS=P2^0;		// LCD RS
sbit LCD_RW=P2^1;		// LCD RW
sbit LCD_CE=P2^2;		// LCD CE

sbit buzzer=P2^4;		// 

char *ptr;			//  

code unsigned char MSG1[]="20";
code unsigned char MSG2[]=".";
code unsigned char MSG3[]=":";

code unsigned char MSG_SUN[]="Sun";
code unsigned char MSG_MON[]="Mon";
code unsigned char MSG_TUE[]="Tue";
code unsigned char MSG_WED[]="Wed";
code unsigned char MSG_THU[]="Thu";
code unsigned char MSG_FRI[]="Fri";
code unsigned char MSG_SAT[]="Sat";

code unsigned char MSG_AM[]="AM ";
code unsigned char MSG_PM[]="PM ";

unsigned char second, minute, hour, ampm, date, month, day, year;

void delay(unsigned int i)    	// ð Լ
{
	while(i--);
}

void beep(void)    		// 
{
	buzzer=0;
	delay(0x4200);
	buzzer=1;
}

void lcd_busy(void)		//  ÷׸ ˻ϴ Լ
{
	unsigned char busy;

	LCD_CE=0;		// LCD 𽺿̺
	busy_flag=1;		// P0.7=High
	LCD_RW=1;		// R/W=High(Read)
	LCD_RS=0;		// LCD_RS=L(Instruction)
	do {
		busy=P0;
		LCD_CE=0;
		LCD_CE=1;
	} while(busy&=0x80);
	LCD_CE=0;		// LCD 𽺿̺
}

void cmd_write(unsigned char Command)	// LCD ɾ  Լ
{
	P0=Command;
	LCD_RS=0;		// LCD_RS=Low(Instruction)
	LCD_RW=0;		// R/W=Low(Write)
	LCD_CE=1;		// LCD ο̺
	LCD_CE=0;		// LCD 𽺿̺
	lcd_busy();
}

void data_write(unsigned char Data)	// LCD ͸  ƾ
{
	P0=Data;
	LCD_RS=1;		// LCD_RS=H(Data)
	LCD_RW=0;		// R/W=L(Write)
	LCD_CE=1;		// LCD ο̺
	LCD_CE=0;		// LCD 𽺿̺
	lcd_busy();
}

void lcd_initialze(void)	// LCD ʱȭ
{
	cmd_write(0x38);	//  (8Ʈ, 5x7Ʈ, 2)
	delay(0x0200);		// ù ° (4.1ms ̻)
	cmd_write(0x38);
	delay(0x08);		//  ° (100us ̻)
	cmd_write(0x38);
	cmd_write(0x0c);	// ÷  ɾ(ǥ on, Ŀ on,  off)
	cmd_write(0x06);	// Ʈ  (巹 , Ʈ )
	cmd_write(0x01);	// ÷ Ŭ, Ŀ Ȩ ġ
}

void disp_data(unsigned char Data)	// LCD ð ͸ ÷ϴ Լ
{
	unsigned char temp;

	temp=Data;
	temp=temp >> 4;
	temp=temp+0x30;		// ASCII ڵ ȯ
  	data_write(temp);	// LCD  4Ʈ ÷

	temp=Data & 0x0f;
	temp=temp+0x30;		// ASCII ڵ ȯ
  	data_write(temp);	// LCD  4Ʈ ÷
}

void disp_msg(void)		// LCD ޽ ÷ϴ Լ
{
	char *str;

	str=ptr;
	do {
 		data_write(*str);
		str++;
	} while(*str);
}

void rtc_initialze(void)	// DS12C887 ʱȭ
{
	RTC_CS=0;
	REGA=0x2f;		//  A ʱȭ( on, SQW=2Hz)
	REGB=0x00;		//  B ʱȭ(12, BCD, ͷƮ 𽺿̺)
	RTC_CS=1;
}

void year_set(void)		//  ϴ Լ
{
	unsigned char esc;
	while(sw1);		// ġ off  
	cmd_write(0x82);	// Ŀ 1 3 ű
	cmd_write(0x0f);	// ÷  ɾ(÷ on, Ŀ on,  on)
	RTC_CS=0;
	year=RTC_YER;		//  
	RTC_CS=1;

	esc=1;
	do {
		if (sw2) esc=0;
		if (sw3) {		//  +1
			while(sw3);
			year++;
			if (year==0x0a) year=0x10;
			else if (year==0x1a) year=0x20;
			else if (year==0x2a) year=0x30;
			else if (year==0x3a) year=0x40;
			else if (year==0x4a) year=0x50;
			else if (year==0x5a) year=0x60;
			else if (year==0x6a) year=0x70;
			else if (year==0x7a) year=0x80;
			else if (year==0x8a) year=0x90;
			else if (year==0x9a) year=0x00;
			disp_data(year);	// LCD   2ڸ ÷
			cmd_write(0x82);	// Ŀ 1 3 ű
		}
	} while(esc);
	RTC_CS=0;
	RTC_YER=year;		// DS12C887 (  )
	RTC_CS=1;
}

void mont_set(void)		//  ϴ Լ
{
	unsigned char esc;
	while(sw2);		// ġ off  
	cmd_write(0x85);	// Ŀ 1 6 ű
	RTC_CS=0;
	month=RTC_MON;		//  
	RTC_CS=1;
	month &= 0x1f;

	esc=1;
	do {
		if (sw2) esc=0;
		if (sw3) {			//  +1
			while(sw3);		// ġ off  
			month++;
			if (month==0x0a) month=0x10;
			else if (month==0x13) month=0x01;
			disp_data(month);	// LCD  ÷
			cmd_write(0x85);	// Ŀ 1 6 ű
		}
	} while(esc);
	RTC_CS=0;
	RTC_MON=month;		// DS12C887 (  )
	RTC_CS=1;
}

void date_set(void)		//  ϴ Լ
{
	unsigned char esc;
	while(sw2);		// ġ off  
	cmd_write(0x88);	// Ŀ 1 9 ű
	RTC_CS=0;
	date=RTC_DAT;		//  
	RTC_CS=1;
	date &= 0x3f;

	esc=1;
	do {
		if (sw2) esc=0;
		if (sw3) {			//  +1
			while(sw3);		// ġ off  
			date++;
			if (date==0x0a) date=0x10;
			else if (date==0x1a) date=0x20;
			else if (date==0x2a) date=0x30;
			else if (date==0x32) date=0x01;
			disp_data(date);	// LCD  ÷
			cmd_write(0x88);	// Ŀ 1 9 ű
		}
	} while(esc);
	RTC_CS=0;
	RTC_DAT=date;				// DS12C887 (  )
	RTC_CS=1;
}

void day_display(unsigned char week)		//  ÷ϴ Լ
{
	switch(week) {
		case 1: 
			ptr=MSG_SUN; disp_msg(); break;	// LCD 'Sun' ÷
		case 2: 
			ptr=MSG_MON; disp_msg(); break;	// LCD 'Mon' ÷
		case 3:
			ptr=MSG_TUE; disp_msg(); break;	// LCD 'Tue' ÷
		case 4:
			ptr=MSG_WED; disp_msg(); break;	// LCD 'Wed' ÷
		case 5:
			ptr=MSG_THU; disp_msg(); break;	// LCD 'Thu' ÷
		case 6:
			ptr=MSG_FRI; disp_msg(); break;	// LCD 'Fri' ÷
		case 7:
			ptr=MSG_SAT; disp_msg(); break;	// LCD 'Sat' ÷
	}
}

void day_set(void)		//  ϴ Լ
{
	unsigned char esc;
	while(sw2);		// ġ off  
	cmd_write(0x8b);	// Ŀ 1 12 ű
	RTC_CS=0;
	day=RTC_DAY;		//  
	RTC_CS=1;
	day &= 0x07;

	esc=1;
	do {
		if (sw2) esc=0;
		if (sw3) {			//  +1
			while(sw3);		// ġ off  
			day++;
			if (day==0x08) day=0x01;
			day_display(day);
			cmd_write(0x8b);	// Ŀ 1 12 ű
		}
	} while(esc);
	RTC_CS=0;
	RTC_DAY=day;		// DS12C887 (  )
	RTC_CS=1;
}

void ampm_set(void)		// /ĸ ϴ Լ
{
	unsigned char esc;
	while(sw2);		// ġ off  
	cmd_write(0xc0);	// Ŀ 2 1 ű
	RTC_CS=0;
	hour=RTC_HOR;		// ø 
	RTC_CS=1;
	ampm=hour & 0x80;

	esc=1;
	do {
		if (sw2) esc=0;
		if (sw3) {			// / 
			while(sw3);		// ġ off  
			if (ampm) {
				ampm=0;
				ptr=MSG_AM;	// LCD 'AM' ÷
				disp_msg();
			}
			else {
				ampm=1;
				ptr=MSG_PM;	// LCD 'PM' ÷
				disp_msg();
			}
			cmd_write(0xc0);	// Ŀ 2 1 ű
		}
	} while(esc);
	if (ampm) hour=hour | 0x80;
	else hour=hour & 0x7f;
	RTC_CS=0;
	RTC_HOR=hour;		// DS12C887 ( / )
	RTC_CS=1;
}

void hour_set(void)		// ø ϴ Լ
{
	unsigned char esc, temp;
	while(sw2);		// ġ off  
	cmd_write(0xc3);	// Ŀ 2 4 ű
	RTC_CS=0;
	hour=RTC_HOR;		// ø 
	RTC_CS=1;

	temp=hour & 0x80;
	hour=hour & 0x7f;

	esc=1;
	do {
		if (sw2) esc=0;
		if (sw3) {			// ø +1
			while(sw3);		// ġ off  
			hour++;
			if (hour==0x0a) hour=0x10;
			else if (hour==0x13) hour=0x01;
			disp_data(hour);	// LCD  ÷
			cmd_write(0xc3);	// Ŀ 2 4 ű
		}
	} while(esc);
	hour=hour | temp;
	RTC_CS=0;
	RTC_HOR=hour;		// DS12C887 (  )
	RTC_CS=1;
}

void mint_set(void)		//  ϴ Լ
{
	unsigned char esc;
	while(sw2);		// ġ off  
	cmd_write(0xc6);	// Ŀ 2 7 ű
	RTC_CS=0;
	minute=RTC_MIN;		//  
	RTC_CS=1;
	minute &= 0x7f;

	esc=1;
	do {
		if (sw2) esc=0;
		if (sw3) {			//  +1
			while(sw3);		// ġ off  
			minute++;
			if (minute==0x0a) minute=0x10;
			else if (minute==0x1a) minute=0x20;
			else if (minute==0x2a) minute=0x30;
			else if (minute==0x3a) minute=0x40;
			else if (minute==0x4a) minute=0x50;
			else if (minute==0x5a) minute=0x00;
			disp_data(minute);	// LCD  ÷
			cmd_write(0xc6);	// Ŀ 2 7 ű
		}
	} while(esc);
	RTC_CS=0;
	RTC_MIN=minute;		// DS12C887 (  )
	RTC_CS=1;
}

void secd_set(void)		// ʸ ϴ Լ
{
	unsigned char esc;
	while(sw2);		// ġ off  
	cmd_write(0xc9);	// Ŀ 2 10 ű
	RTC_CS=0;
	second=RTC_SEC;		// ʸ 
	RTC_CS=1;
	second &= 0x7f;

	esc=1;
	do {
		if (sw1) esc=0;
		if (sw2) esc=0;
		if (sw3) {		// ʸ +1
			while(sw3);	// ġ off  
			second++;
			if (second==0x0a) second=0x10;
			else if (second==0x1a) second=0x20;
			else if (second==0x2a) second=0x30;
			else if (second==0x3a) second=0x40;
			else if (second==0x4a) second=0x50;
			else if (second==0x5a) second=0x00;
			disp_data(second);	// LCD  ÷
			cmd_write(0xc9);	// Ŀ 2 10 ű
		}
	} while(esc);
	RTC_CS=0;
	RTC_SEC=second;		// DS12C887 (  )
	RTC_CS=1;
	cmd_write(0x0c);	// ÷  ɾ(÷ on, Ŀ off,  off)
}

void disp_time(void)		// LCD ð  ÷ϴ Լ
{
	cmd_write(0x80);	// Ŀ 1 1 ű
	ptr=MSG1;		// LCD '20' ÷
	disp_msg();

	RTC_CS=0;
	year=RTC_YER;		//  
	RTC_CS=1;
	disp_data(year);	//   2ڸ ǥ
	ptr=MSG2;		// LCD '.' ÷
	disp_msg();

	RTC_CS=0;
	month=RTC_MON;		//  
	RTC_CS=1;
	disp_data(month);
	ptr=MSG2;		// LCD '.' ÷
	disp_msg();

	RTC_CS=0;
	date=RTC_DAT;		//  
	RTC_CS=1;
	disp_data(date);	// LCD  ÷
	ptr=MSG2;		// LCD '.' ÷
	disp_msg();

	RTC_CS=0;
	day=RTC_DAY;		//  
	RTC_CS=1;
	day_display(day);	// LCD  ÷

	cmd_write(0xc0);	// Ŀ 2 1 ű
	RTC_CS=0;
	hour=RTC_HOR;		// ø 
	RTC_CS=1;

	if (hour & 0x80) {
		ptr=MSG_PM;	// LCD 'PM' ÷
		disp_msg();
	}
	else {
		ptr=MSG_AM;	// LCD 'AM' ÷
		disp_msg();
	}

	RTC_CS=0;
	hour=RTC_HOR;		// ø 
	RTC_CS=1;
	disp_data(hour & 0x7f);	// LCD  ÷
	ptr=MSG3;		// LCD '.' ÷
	disp_msg();

	RTC_CS=0;
	minute=RTC_MIN;		//  
	RTC_CS=1;
	disp_data(minute);	// LCD  ÷
	ptr=MSG3;		// LCD ':' ÷
	disp_msg();

	RTC_CS=0;
	second=RTC_SEC;		// ʸ 
	RTC_CS=1;
	disp_data(second);	// LCD  ÷

	if (minute==0) {
		if (second==0) beep();
	}
}

void sec_reset(void)		// ʸ 00 ϴ Լ
{
	while(sw4);
	RTC_CS=0;
	RTC_SEC=0x00;		// =0
	RTC_CS=1;
}

void main(void)
{
	lcd_initialze();		// LCD ʱȭ
	rtc_initialze();		// DS12C887 ʱȭ
	do {
		if (sw1) {		// sw1 ˻
			year_set();	//  
			mont_set();	//  
			date_set();	//  
			day_set();	//  
			ampm_set();	// /ĸ 
			hour_set();	// ø 
			mint_set();	//  
			secd_set();	// ʸ 
			disp_time();	//  ð ÷
		}
		else if (sw4) {		// sw4 ˻
			sec_reset();	// ʸ 0 
			disp_time();	//  ð ÷
		}
		else {
			delay(0x04d0);
			disp_time();	//  ð ÷
		}
	} while(1);
}