// DS1620 ̿  µ  ġ

#include <reg51.h>

sbit DQ=P1^0;			// DS1620   
sbit CLK=P1^1;			// DS1620 CLK
sbit RST=P1^2;			// DS1620 RST
sbit minus=P1^3;		//  Ǵ  ÷
sbit degree=P1^4;		// Ҽ  ÷(0 Ǵ 5)

void delay(unsigned int i)	// ð 
{
	while(i--);
}

void ds_write(unsigned char t_data)	// ɾ (8051DS1620)
{
	unsigned char i;
	for (i=0; i<8; i++) {
        	CLK=0;			// CLK=Low
        	delay(10); 
        	DQ=t_data & 0x01;	// ɾ 
        	CLK=1;			// CLK=High
        	delay(10); 
        	t_data >>= 1;		//  1Ʈ Ʈ
	}
}

void ds_write_9bit(unsigned char t_sign, unsigned char t_data)
{					// 9Ʈ  (8051DS1620)
	unsigned char i;
	for (i=0; i<8; i++) {
        	CLK=0; 			// CLK=Low
        	delay(10); 
        	DQ=t_data & 0x01; 	//  
        	CLK=1; 			// CLK=High
        	delay(10);
        	t_data >>= 1;		//  1Ʈ Ʈ
	}
	CLK=0; 				// CLK=Low
	delay(10);
	DQ=t_sign;			// ȣƮ 
	CLK=1; 				// CLK=High
	delay(10);
}

unsigned char ds_read(void)		//  б(DS16208051)
{
	unsigned char i, g_data, temp;
	g_data=0x00;
	temp=0x01;   				// 0000 0001B

	for (i=0; i<8; i++) {
        	CLK=0; 				// CLK=Low
        	delay(10);
        	if (DQ==1) g_data |= temp;	//  б
        	CLK=1; 				// CLK=High
        	delay(10); 
        	temp=temp<<1;
	} 
	return g_data;
}

// 3 Alarm Thermostat Operation
void set_TH(unsigned char th_sign, unsigned char th_data)
{
	RST=1;					// RST=High
	delay(10);
	ds_write(0x01);				// TH Ϳ ͸  
	ds_write_9bit(th_sign,th_data);		// TH  (LSB )
	RST=0; 					// RST=Low
	delay(10);				// 
	delay(2000);
}

void set_TL(unsigned char tl_sign, unsigned char tl_data)
{
	RST=1; 					// RST=High
	delay(10);
	ds_write(0x02);				// TL Ϳ ͸  
	ds_write_9bit(tl_sign,tl_data);		// TL  (LSB )
	RST=0; 					// RST=Low
	delay(10); 				// 
	delay(2000);
}

// 9Ʈ (2 Bytes)κ µ
// data2: ȣ, data1: µ
void display_temp(unsigned char data2, unsigned char data1)
{
	unsigned char temp, d100, d10, d1;

	if (data2==0x01) {	// 0000 0001B濵ǥ
        	minus=0;
        	data1=~data1;
        	data1 += 1;	// 2 
	} else {
		minus=1;	//  ÷
	}

	temp=data1 & 0x01;	// 0.5  0.0  
	data1 >>= 1;		// µ=data1  Ʈ
	d100=data1/100; 
	d10=(data1%100)/10;
	d1=(data1%100)%10;

	if (temp) degree=1;	// 7-׸Ʈ Ҽ   5 ÷
	else degree=0;		// 7-׸Ʈ Ҽ   0 ÷
	P2=(d10<<4) | d1;	// 7-׸Ʈ µ ÷
}

void main(void)
{
	unsigned char get_data1, get_data2;

    				// ʱȭ    ۸ 
    				// 1 Shot ۸(0x03), ӵ۸(0x02)
	RST=0; 			// ʱȭ, RST=Low
	delay(10);
	CLK=1;			// CLK=High
	delay(10);

	RST=1; 			// RST=High
	delay(10);
	ds_write(0x0c);		//  Ϳ ͸  
	ds_write(0x02);		//  Ϳ   ( ۸)
	RST=0; 			// RST=Low
	delay(10);		// 
	delay(2000);

// µ   TH  TL 
// (EX) TH=+28[]-> 28*2=56=00 38H
//      TL=+26[]-> 26*2=52=00 34H
//          +25[]-> 50,00 32H 
//          +23[]-> 46,00 2EH 
//          +22[]-> 44,00 2CH
//          +21[]-> 42,00 2AH 
//          +20[]-> 40,00 28H 
//
//         +125[]-> 00 FAH
//         - 55 []-> 01 92H

	set_TH(0x00,0x38);	// TH (+28)
	set_TL(0x00,0x34);	// TL (+26)

	RST=1;			// RST=High
	delay(10);
	ds_write(0x22);		// µ ȯ  
	RST=0; 			// RST=Low
	delay(10);

	RST=1; 			// RST=High
	delay(10);
	ds_write(0xee);		// µ ȯ  
	RST=0; 			// RST=Low
	delay(10);

	delay(50000);		// ȯ  0.75 
	delay(50000);
 
	do {
		RST=1; 			// RST=High
		delay(10);
		ds_write(0xaa);		// µ  б 
		get_data1=ds_read();	// µ 
		get_data2=ds_read();	// ȣ
		RST=0; 			// RST=Low
		delay(10);
		display_temp(get_data2,get_data1);	// µ ϰ 7-׸Ʈ ÷
	} while(1);
} 
